<template>
  <div class="props">
    <t-collapse
      :defaultValue="['1', '2', '3', '7']"
      expandIconPlacement="right"
      :borderless="true"
    >
    <t-collapse-panel  v-if="props.pen.formId" value="7" header="表单">
          <!-- 表单子图元 -->
          <div class="form-item px-12">
            <label title="所属表单">所属表单 </label>
            <div class="ml-8" :title="leaderPen?.id">{{ leaderPen?.description||leaderPen?.name }}</div>
          </div>
          <div class="form-item px-12">
            <label>表单key </label>
            <t-input
              class="w-full"
              v-model="props.pen.formKey"
              @change="changeValue('formKey')"
            />
          </div>
          <div class="form-item px-12">
            <label>表单value </label>
            <t-input
              class="w-full"
              v-model="props.pen.formValue"
              @change="changeValue('formValue')"
            />
          </div>
          <div class="form-item px-12">
            <label>表单类型 </label>
            <t-select
              class="w-full"
              v-model="props.pen.formType"
              placeholder="选择变量"
            >
            <t-option key="submit" value="submit" label="提交"/>
            <t-option key="reset" value="reset" label="重置"/>
          </t-select>
          </div>
      </t-collapse-panel>
      <!-- <t-collapse-panel value="1" header="通信">
        <t-space direction="vertical" size="small" class="w-full">
          <div class="form-item">
            <label title="http地址">http地址 </label>
            <t-input
              class="w-full"
              v-model="props.pen.apiUrl"
              @change="changeValue('apiUrl')"
            />
          </div>
          <div class="form-item">
            <label title="请求方式">请求方式</label>
            <t-select
              v-model="props.pen.apiMethod"
              @change="changeValue('apiMethod')"
            >
              <t-option key="GET" value="GET" label="GET" />
              <t-option key="POST" value="POST" label="POST" />
            </t-select>
          </div>
          <div class="form-item">
            <label title="请求头">请求头</label>
            <t-button
              class="ml-8"
              shape="square"
              variant="outline"
              style="width: 24px"
              @click="preShowPropsEdit('apiHeaders')"
            >
              <ellipsis-icon slot="icon"/>
          </t-button>
          </div>
          <div class="form-item" v-if="props.pen.apiMethod === 'POST'">
            <label title="请求体">请求体</label>
            <t-button
              class="ml-8"
              shape="square"
              variant="outline"
              style="width: 24px"
              @click="preShowPropsEdit('apiBody')"
            >
              <ellipsis-icon slot="icon"/>
            </t-button>
          </div>
          <div class="form-item">
            <label title="开启轮询">开启轮询</label>
            <t-switch
              class="mt-8 ml-8"
              v-model="props.pen.apiEnable"
              size="small"
              @change="changeValue('apiEnable')"
            />
          </div>
        </t-space>
      </t-collapse-panel> -->
      <!-- <t-collapse-panel v-if="props.pen.props.custom" value="2" header="属性">
        <t-space direction="vertical" size="small" class="w-full">
          <div v-for="item in props.pen.props.custom" class="form-item">
            <label :title="item.label">{{ item.label }}</label>
            <t-checkbox
              class="ml-8"
              v-if="item.type === 'bool'"
              v-model="props.pen[item.key]"
              @change="changeValue(item.key)"
            />
            <t-input-number
              class="w-full"
              v-else-if="item.type === 'number'"
              v-model.number="props.pen[item.key]"
              theme="column"
              :max="item.max"
              :min="item.min"
              @change="changeValue(item.key)"
              :placeholder="item.placeholder"
              :allowInputOverLimit="false"
              :decimalPlaces="2"
            />
            <t-color-picker
              class="w-full"
              v-else-if="item.type === 'color'"
              :enable-alpha="true"
              :recent-colors="null"
              format="CSS"
              :swatch-colors="defaultPureColor"
              :color-modes="['monochrome']"
              :show-primary-color-preview="false"
              v-model="props.pen[item.key]"
              @change="changeValue(item.key)"
              :placeholder="item.placeholder"
            />
            <t-select
              class="w-full"
              v-else-if="item.type === 'select'"
              size="small"
              :options="item.options"
              v-model="props.pen[item.key]"
              @change="changeValue(item.key)"
              :placeholder="item.placeholder"
            />
            <t-button
              class="ml-8"
              v-else-if="item.type === 'code'"
              shape="square"
              variant="outline"
              style="width: 24px"
              @click="showDrawer(item)"
            >
              <ChevronLeftDoubleIcon slot="icon"/>
            </t-button>
            <t-slider
              v-else-if="item.type === 'slider'"
              v-model="props.pen[item.key]"
              :min="0"
              :max="1"
              :step="0.01"
              @change="changeValue(item.key)"
            />
            <t-switch
              size="small"
              class="mt-8 ml-8"
              v-else-if="item.type === 'switch'"
              v-model="props.pen[item.key]"
              @change="changeValue(item.key)"
            />
            <t-input
              class="w-full"
              v-else
              v-model="props.pen[item.key]"
              @change="changeValue(item.key)"
              :placeholder="item.placeholder"
            />
          </div>
        </t-space>
      </t-collapse-panel> -->

      <t-collapse-panel value="3" :header="$t('数据')">
        <div class="form-item" v-if="props.pen.name==='tablePlus'">
          <label class="label">{{$t('数据源')}}</label>
          <t-select v-model="dataSource" @change="getDataSource" :placeholder="$t('请选择')">
            <t-option key="api" value="api" :label="$t('API接口')"></t-option>
            <t-option key="csv" value="csv" :label="$t('CSV文件')"></t-option>
            <t-option key="excel" value="excel" :label="$t('从Excel导入')"></t-option>
          </t-select>
        </div>
        <div class="t-space-item" v-if="props.pen.name==='tablePlus'">
          <div v-if="cell.row!==undefined" class="flex between form-item  py-12">
              <div  v-if="cell.col!==undefined"  style="line-height: 30px">
                {{$t( '当前选中单元格' )}}  ({{$t( '第' )}}{{ props.pen.colHeaders? cell.row:cell.row+1 }}{{$t( '行' )}}，{{$t( '第' )}}{{ cell.col}}{{$t( '列' )}})
              </div>
              <div v-else style="line-height: 30px">
                {{$t( '当前选中行' )}}  ({{$t( '第' )}}{{ props.pen.colHeaders? cell.row:cell.row+1 }}{{$t( '行' )}})
              </div>
              <div>
                <t-tooltip placement="top" :content="$t('快捷绑定')">
                 <link-icon style="width: 13px;margin-right: 26px" class="hover ml-4" @click="onQuickBind()"></link-icon>
                </t-tooltip>
              </div>
          </div>
        </div>
        <div class="t-space-item">
          <div class="form-item  py-12">
              <label style="width: 76px">{{$t('关联设备')}}</label>
              <t-input class="w-full" v-model="props.pen.deviceId" @change="changeValue('deviceId')" :placeholder="$t('设备ID')"></t-input>
          </div>
        </div>
        <div class="real-times" v-if="props.pen.realTimes && props.pen.realTimes.length||pen.children?.length">
          <div class="grid head">
            <div class="title">{{$t('数据名')}}</div>
            <div class="title">{{$t('值')}}</div>
            <div class="title" style="text-align: center;">{{$t('绑定')}}</div>
            <div class="title" style="text-align: center;">{{$t('操作')}}</div>

            <!-- <div class="actions">
              <more-icon />
            </div> -->
          </div>
          <div class="grid" v-for="(item, i) in props.pen.realTimes">
            <t-tooltip :content="item.key" placement="top">
              <label class="label">{{ item.label }}</label>
            </t-tooltip>
            <div class="value">
              <t-input
                v-if="item.type === 'integer'"
                v-model.number="props.pen[item.key]"
                :placeholder="$t('整数')"
                @change="changeValue(item.key)"
              />
              <t-input-number
                v-else-if="item.type === 'float'"
                v-model="props.pen[item.key]"
                :placeholder="$t('浮点数')"
                theme="normal"
                @change="changeValue(item.key)"
              />
              <t-switch
                v-else-if="item.type === 'bool'"
                v-model="props.pen[item.key]"
                class="ml-8"
                size="small"
                @change="changeValue(item.key)"
              />
              <t-button
                v-else-if="item.type === 'array' || item.type === 'object'"
                variant="outline"
                style="padding: 0px 2px 0 4px; margin: 0 4px"
                @click="editObject(item)"
              >
                <ellipsis-icon />
                <!-- <t-icon name="ellipsis" /> -->
              </t-button>
              <t-input v-else v-model="props.pen[item.key]" @change="changeValue(item.key)" :placeholder="$t('字符串')"></t-input>

             
            </div>
            <div style="text-align: center;">
              <t-tooltip :content="getBindsDesc(item)" placement="top">
                <link-icon class="hover ml-4"
                  :class="{ primary: item.enableMock || item.bind?.id }"
                  @click="onBind(item)"/>
              </t-tooltip>
            </div>
            <div style="text-align: center;">
              <!-- <t-tooltip :content="item.triggers?.length || '状态'">
                <t-badge
                  :count="item.triggers?.length"
                  size="small"
                  dot
                  :offset="[0, 5]"
                >
                  <relativity-icon  class="hover"
                    @click="onTrigger(item)"/>
                </t-badge>
              </t-tooltip> -->
                <t-dropdown
                  :options="triggerOptions"
                  @click="addTrigger(item, $event, i)"
                  :minColumnWidth="120"
                >
                  <ViewListIcon class="hover"/>
                </t-dropdown>
            </div>
            <!-- <div class="actions">
              <t-dropdown
                :options="moreOptions"
                @click="onMenuMore($event, item, i)"
                :minColumnWidth="80"
              >
                <more-icon class="more hover" />
              </t-dropdown>
            </div> -->
          </div>
          <div class="mt-8 pb-16">
            <t-dropdown
              :options="options"
              @click="addRealTime"
              :minColumnWidth="150"
            >
              <a class="ml-12">
                <add-rectangle-icon />
                <!-- <t-icon name="add-rectangle" />  -->
                {{$t('添加动态数据')}}
              </a>
            </t-dropdown>
          </div>
        </div>
        <div class="flex column center blank" v-else>
          <img src="/img/blank.png">
          <div class="gray center">{{$t('还没有动态数据')}}</div>
          <div class="mt-8">
            <t-dropdown
              :options="options"
              @click="addRealTime"
              :minColumnWidth="150"
            >
              <t-button style="height: 30px"> 添加动态数据 </t-button>
            </t-dropdown>
          </div>
        </div>
        <div v-if="props.pen.children?.length" class="c-titile">
          <t-tooltip :content="$t('ctrl+shift+点击，可选中子图元')">
            {{$t('子图元')}}
          </t-tooltip>
        </div>
        <template v-for="(cPen) in childrenPens">
          <div
          class="real-times"
        >
          <div class="flex mt-8 mb-8 between">
            <div> {{ cPen.description||cPen.name }}</div>
            <t-dropdown
              :options="options"
              @click="addCRealTime($event,cPen)"
              :minColumnWidth="150"
            >
              <a class="ml-12">
                <add-rectangle-icon></add-rectangle-icon>
                {{$t('添加动态数据')}}
              </a>
            </t-dropdown>
          </div>
          <div class="grid" v-for="(item, i) in cPen.realTimes">
            <t-tooltip :content="item.key" placement="top">
              <label class="label">{{ item.label }}</label>
            </t-tooltip>
            <div class="value">
              <t-input
                v-if="item.type === 'integer'"
                v-model.number="cPen[item.key]"
                :placeholder="$t('整数')"
                @change="changeCValue(item.key,cPen)"
              />
              <t-input-number
                v-else-if="item.type === 'float'"
                v-model="cPen[item.key]"
                :placeholder="$t('浮点数')"
                theme="normal"
                @change="changeCValue(item.key,cPen)"
              />
              <t-switch
                v-else-if="item.type === 'bool'"
                v-model="cPen[item.key]"
                class="ml-8"
                size="small"
                @change="changeCValue(item.key,cPen)"
              />
              <t-button
                v-else-if="item.type === 'array' || item.type === 'object'"
                variant="outline"
                style="padding: 0px 2px 0 4px; margin: 0 4px"
                @click="editCObject(item,cPen)"
              >
                <ellipsis-icon />
              </t-button>
              <t-input
                v-else
                v-model="cPen[item.key]"
                :placeholder="$t('字符串')"
                @change="changeCValue(item.key,cPen)"
              />


            </div>
            <div style="text-align: center;">
              <t-tooltip :content="getBindsDesc(item)" placement="top">
                <link-icon class="hover ml-4"
                  :class="{ primary: item.enableMock || item.bind?.id }"
                  @click="onBind(item)"/>
              </t-tooltip>
            </div>
            <!-- <div>
              <t-tooltip :content="item.triggers?.length || '状态'">
                <t-badge
                  :count="item.triggers?.length"
                  size="small"
                  dot
                  :offset="[0, 5]"
                >
                  <relativity-icon  class="hover"
                    @click="onTrigger(item)"/>
                </t-badge>
              </t-tooltip>
            </div> -->
            <div class="actions" style="text-align: center;">
              <t-dropdown
                :options="moreOptions"
                @click="onCMenuMore($event, item, i, cPen)"
                :minColumnWidth="80"
              >
                <ViewListIcon class="hover"/>
              </t-dropdown>
            </div>
          </div>
         
        </div>
        </template>
      </t-collapse-panel>
    </t-collapse>
  </div>
  <!-- <t-drawer 
    v-model:visible="drawer.visible" 
    :header="drawer.header" 
    cancelBtn="关闭"
    confirmBtn="运行"
    @confirm="onConfirmDrawer"
    :closeOnOverlayClick="false" 
    :sizeDraggable="true"
    >
    <div style="height:100%">
      <CodeEditor
        style="height: 100%"
        :key="drawer.randomkey"
        :json="true"
        :language="'json'"
        v-model="drawer.value"
      />
    </div>
    <div class="gray" style="font-size: 12px">
      {{ drawer.placeholder }}
    </div>
    </t-drawer> -->
  <t-dialog
    v-if="addDataDialog.show"
    :visible="true"
    class="data-dialog"
    :header="addDataDialog.header"
    @close="addDataDialog.show = false"
    @confirm="onConfirmData"
  >
    <div class="form-item mt-16">
      <label>{{$t('数据名')}}</label>
      <t-input v-model="addDataDialog.data.label" :disabled="!!addDataDialog.data.keywords" @blur="onChangeLabel" :placeholder="$t('简短描述')"></t-input>
    </div>
    <div class="form-item mt-16">
      <label>{{$t('属性名')}}</label>
      <t-input v-model="addDataDialog.data.key" @blur="onKeyBlur" :disabled="!!addDataDialog.data.keywords" :placeholder="$t('关键字')"></t-input>
    </div>
    <div class="form-item mt-16">
      <label>{{$t('类型')}}</label>
      <t-select class="w-full" :options="typeOptions" v-model="addDataDialog.data.type" :disabled="!!addDataDialog.data.keywords" @change="onKeyBlur" :placeholder="$t('字符串')"></t-select>
    </div>
  </t-dialog>

  <t-dialog
    v-if="dataBindDialog.show"
    :visible="true"
    class="data-link-dialog"
    :header="$t('动态数据设置')"
    @close="
      dataBindDialog.datasetList = undefined;
      dataBindDialog.show = false;
    "
    @confirm="dataBindonConfirm"
    :top="70"
    :width="700"
  >
    <t-tabs :defaultValue="1">
      <t-tab-panel :value="1" :destroy-on-hide="false" style="height: 420px" :label="$t('绑定变量')">
        <div class="form-item mt-12">
          <label>{{$t('当前绑定')}}：</label>
          <div class="label" v-if="dataBindDialog.data.bind?.id">
            <t-tooltip :content="dataBindDialog.data.bind?.id">
              <t-tag class="mr-8 mb-8" closable @close="onRemoveBind()">
                {{ dataBindDialog.data.bind?.label }}
              </t-tag>
            </t-tooltip>
          </div>
          <div class="label gray" v-else>{{$t('无')}}</div>
        </div>
        <div class="form-item flex middle mt-8">
          <!-- <t-input
            v-if="dataBindDialog.url"
            v-model="dataBindDialog.device"
            placeholder="设备"
            style="width: 200px"
          />
          <t-select
            v-else
            class="mr-16"
            style="width: 200px"
            v-model="dataBindDialog.device"
            clearable
            placeholder="设备"
            @change="getDataset"
          >
            <t-option
              v-for="(item, i) in dataBindDialog.devices"
              :key="item"
              :value="item"
              :label="item"
            />
          </t-select> -->

          <t-input style="width:250px;" v-model="dataBindDialog.input" @change="onSearchDataset" @enter="onSearchDataset" :placeholder="$t('搜索')">
            <template #suffixIcon>
              <search-icon class="hover" @click="onSearchDataset"/>
              <!-- <t-icon name="search" class="hover" @click="onSearchDataset" /> -->
            </template>
          </t-input>
        </div>
        <t-table
          class="mt-12 data-list"
          row-key="id"
          :data="dataBindDialog.dataset"
          :columns="dataSetColumns"
          size="small"
          bordered
          rowSelectionAllowUncheck
          :loading="dataBindDialog.loading"
          :pagination="query"
          @page-change="onChangePagination"
          :selected-row-keys="dataBindDialog.selectedIds"
          @select-change="onSelectBindsChange"
          :max-height="270"
        >
        </t-table>
      </t-tab-panel>
      <t-tab-panel :value="2" :destroy-on-hide="false" style="height: 420px" :label="$t('本地调试')">
        <div class="form-item mt-20">
          <label>{{$t('模拟值')}}：</label>
          <t-input v-model="dataBindDialog.data.mock"></t-input>
        </div>
        <div class="form-item mt-20">
          <label>{{$t('类型')}}：</label>
          <t-select class="w-full" :options="typeOptions" v-model="dataBindDialog.data.type" :placeholder="$t('字符串')"></t-select>
        </div>
        <div class="form-item mt-12">
          <label>{{$t('开启')}}：</label>
          <t-switch class="mt-8" size="small" v-model="dataBindDialog.data.enableMock"></t-switch>
        </div>
        <h6 class="desc mt-20">{{$t('模拟值说明')}}</h6>
        <ul class="desc mt-4">
          <li class="mt-4">
            <label class="inline" style="width: 80px">{{$t('固定值')}}：</label>
            {{$t('直接填写')}}，{{$t('例如')}}：10
          </li>
          <li class="mt-4">
            <label class="inline" style="width: 80px">{{$t('随机值')}}：</label>
            {{$t('值')}}1,{{$t('值')}}2,...。{{$t('例如')}}：1,2,3,4,5
          </li>
          <li class="mt-4">
            <label class="inline" style="width: 80px">{{$t('范围数字')}}：</label>
            {{$t('最小值')}}-{{$t('最大值')}}。{{$t('例如')}}：0-1.0 {{$t('或')}} 0-100
          </li>
          <li class="mt-4">
            <label class="inline" style="width: 80px">{{$t('随机字符串')}}：</label>
            [{{$t('长度')}}]。{{$t('例如')}}：[8]
          </li>
        </ul>
      </t-tab-panel>
    </t-tabs>
  </t-dialog>

  <t-dialog
    v-if="triggersDialog.show"
    :visible="true"
    class="data-events-dialog"
    :header="$t('数据状态')"
    @confirm="triggersDialog.show = false"
    @close="triggersDialog.show = false"
    :width="700"
  >
    <div class="body">
      <t-collapse
        v-model="triggersDialog.openedCollapses"
        :borderless="true"
        :expand-on-row-click="false"
      >
        <t-collapse-panel
          v-for="(trigger, i) in triggersDialog.data.triggers"
          :value="i"
        >
          <template #header>
            <t-input v-model="trigger.name" class="mr-12" />
          </template>
          <template #headerRightContent>
            <t-popconfirm @confirm="triggersDialog.data.triggers.splice(i, 1)" :content="$t('确认删除该状态吗？')">
              <delete-icon class="hover"></delete-icon>
              <!-- <t-icon name="delete" class="hover" /> -->
            </t-popconfirm>
          </template>
          <section>
            <div class="form-item banner">
              <label>{{$t('满足条件')}}</label>
              <div class="w-full flex middle between">
                <div></div>
                <t-radio-group v-model="trigger.conditionType">
                  <t-radio value="and"> {{$t('所有')}} </t-radio>
                  <t-radio value="or"> {{$t('任意')}} </t-radio>
                </t-radio-group>
              </div>
            </div>
            <div v-for="(c, index) in trigger.conditions" class="mb-12">
              <div class="flex middle between head">
                <div class="flex middle">
                  <arrow-right-icon class="mr-4"/>
                  <!-- <t-icon name="arrow-right" class="mr-4" /> -->
{{$t('                  条件')}}{{ index + 1 }}
                </div>
                <close-icon  class="hover"
                  @click="trigger.conditions.splice(index, 1)"/>
                <!-- <t-icon
                  name="close"
                  class="hover"
                  @click="trigger.conditions.splice(index, 1)"
                /> -->
              </div>
              <div class="px-16 py-4">
                <div class="form-item mt-4">
                  <label>{{$t('条件类型')}}</label>
                  <t-radio-group v-model="c.type">
                    <t-radio value> {{$t('关系条件')}} </t-radio>
                    <t-radio value="fn"> {{$t('高级条件')}} </t-radio>
                  </t-radio-group>
                </div>
                <template v-if="!c.type">
                  <div class="form-item mt-8">
                    <label>{{$t('比较条件')}}</label>
                    <div class="flex middle">
                      <label class="shrink-0 mr-8">{{$t('数据')}}</label>
                      <t-select v-model="c.operator" :options="operatorOptions" class="shrink-0 mr-8" style="width: 80px" :placeholder="$t('关系运算')"></t-select>
                      <t-select v-model="c.valueType" class="shrink-0 mr-8" style="width: 110px" :placeholder="$t('固定值')">
                        <t-option key value :label="$t('固定值')">
                          {{$t('固定值')}}
                        </t-option>
                        <t-option key="prop" value="prop" :label="$t('对象属性值')">
                          {{$t('对象属性值')}}
                        </t-option>
                      </t-select>
                      <template v-if="!c.valueType">
                        <t-input
                          @change="valueChange($event,c)"
                          v-model="c.value"
                          class="shrink-0"
                          style="width: 320px"
                        />
                      </template>
                      <template v-else>
                        <t-tree-select
                          v-model="c.target"
                          :data="penTree"
                          filterable
                          :placeholder="$t('对象')"
                          class="shrink-0 mr-8"
                          style="width: 160px"
                          @change="onChangeTriggerTarget(c)"
                        />
                        <t-select-input
                          v-model:inputValue="c.value"
                          :value="c.label"
                          v-model:popupVisible="c.popupVisible"
                          allow-input
                          clearable
                          @clear="c.label = undefined"
                          @focus="c.popupVisible = true"
                          @blur="c.popupVisible = false"
                          @input-change="onInput(c)"
                          class="shrink-0"
                          style="width: 152px"
                        >
                          <template #panel>
                            <ul style="padding: 8px 12px">
                              <li
                                v-for="item in cProps"
                                :key="item.value"
                                @click="
                                  c.value = item.value;
                                  c.label = item.label;
                                  c.popupVisible = false;
                                "
                              >
                                {{ item.label }}
                              </li>
                            </ul>
                          </template>
                        </t-select-input>
                      </template>
                    </div>
                  </div>
                </template>
                <template v-else>
                  <div>function condition(pen) {</div>
                  <CodeEditor class="mt-4" @change="codeChange($event,c)" v-model="c.fnJs" />
                  <div class="mt-4">}</div>
                </template>
              </div>
            </div>
            <div class="mt-8">
              <a @click="addTriggerCondition(trigger)"> + {{$t('添加条件')}} </a>
            </div>

            <div class="form-item banner mt-16">
              <label>{{$t('执行动作')}}</label>
            </div>
            <Actions class="mt-8" :data="trigger" />
          </section>
        </t-collapse-panel>
      </t-collapse>

      <div class="mt-8">
        <!-- <a @click="onAddTrigger"> + 添加状态 </a> -->
        <t-button @click="onAddTrigger" style="width: 100%;" variant="outline">
          <template #icon><add-icon></add-icon></template>
          {{$t('添加状态')}}
        </t-button>
      </div>
    </div>
  </t-dialog>

  <t-dialog v-if="ojbectDialog.show" :visible="true" @confirm="onOkEditOjbect" @close="ojbectDialog.show = false" :width="700" :header="$t('数据编辑')">
    <div class="py-8">
      <CodeEditor
        :json="true"
        v-model="ojbectDialog.data"
        style="height: 300px"
      />
    </div>
  </t-dialog>
  <t-dialog
    v-if="propsDialog.show"
    :visible="true"
    :header="propsDialog.header"
    @confirm="onOkPropsEdit"
    @close="propsDialog.show = false"
    :width="700"
  >
    <div class="py-8">
      <CodeEditor
        :json="true"
        :language="'json'"
        v-model="propsDialog.value"
        style="height: 300px"
      />
    </div>
    <div class="gray" style="font-size: 12px">
      {{ propsDialog.placeholder }}
    </div>
  </t-dialog>

  <t-dialog v-if="apiDialog.show" :visible="true" class="data-dialog" @close="apiDialog.show = false" @confirm="onConfirmAPI" :header="$t('API接口')">
  <div class="form-item mt-8">
      <label>http{{$t('地址')}}</label>
      <t-input v-model="apiDialog.url" :placeholder="$t('请输入（临时请求，不会保存）')"></t-input>
    </div>
    <div class="form-item mt-8">
        <label>{{$t('请求方式')}}</label>
        <t-select v-model="apiDialog.method">
          <t-option key="GET" value="GET" label="GET" />
          <t-option key="POST" value="POST" label="POST" />
        </t-select>
      </div>
      <div class="form-item mt-8">
        <label>{{$t('请求头')}}</label>
        <CodeEditor :json="true" :language="'json'" v-model="apiDialog.headers" class="mt-4" style="height: 50px"></CodeEditor>
      </div>
      <div v-if="apiDialog.method === 'POST'" class="form-item mt-8">
        <label>{{$t('请求体')}}</label>
        <CodeEditor :json="true" :language="'json'" v-model="apiDialog.body" class="mt-4" style="height: 50px"></CodeEditor>
      </div>
  </t-dialog>
</template>

<script lang="ts" setup>
import {
  getCurrentInstance,
  onBeforeMount,
  onUnmounted,
  reactive,
  ref,
  toRaw,
  watch,
  onMounted,
  computed
} from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { MessagePlugin } from 'tdesign-vue-next';
import axios from 'axios';
import { debounce } from '@/services/debouce';
import { getPenTree, typeOptions, changeType } from '@/services/common';
import { searchPinyin } from '@/services/pinyin';
import { updatePen } from './pen';
import { getter, setter, queryURLParams, deepClone, getAllChildren, Pen } from '@meta2d/core';
import CodeEditor from '@/views/components/common/CodeEditor.vue';
import Actions from './Actions.vue';
import { useSelection } from '@/services/selections';
import { defaultGradientColor, defaultPureColor } from '@/services/defaults';
import { getLe5le3d, getLe5leV, getLe5le2d } from '@/services/api';
import { EllipsisIcon, MoreIcon, LinkIcon, RelativityIcon, AddRectangleIcon, SearchIcon ,DeleteIcon, ArrowRightIcon, CloseIcon, ChevronLeftDoubleIcon, AddIcon, ViewListIcon } from 'tdesign-icons-vue-next';
import { s8 } from '@/services/random';
import { importExcel } from '@/services/excel';
import { importCSV } from '@/services/file';

const route = useRoute();
const router = useRouter();
const { proxy } = getCurrentInstance();
const $t = proxy.$t
const {
  proxy: { $forceUpdate },
}: any = getCurrentInstance();

const props = defineProps<{
  pen: any;
}>();

const options = ref<any>([
  {
    value: '',
    content: $t('自定义'),
    divider: true,
  },
  {
    value: 'x',
    content: 'X',
    type: 'float',
    keywords: true,
  },
  {
    value: 'y',
    content: 'Y',
    type: 'float',
    keywords: true,
  },
  {
    value: 'width',
    content: $t('宽'),
    type: 'float',
    keywords: true,
  },
  {
    value: 'height',
    content: $t('高'),
    type: 'float',
    keywords: true,
  },
  {
    value: 'visible',
    content: $t('显示'),
    type: 'bool',
    keywords: true,
  },
  {
    value: 'text',
    content: $t('文字'),
    // keywords: true,
  },
  {
    value: 'progress',
    content: $t('进度'),
    type: 'float',
    keywords: true,
  },
  {
    value: 'showChild',
    content: $t('状态'),
    type: 'integer',
    keywords: true,
  },
  {
    value: 'rotate',
    content: $t('旋转'),
    type: 'integer',
    keywords: true,
  },
]);

const moreOptions = ref<any>([
  {
    value: 'view',
    content: $t('查看状态'),
  },
  {
    value: 'custom',
    content: $t('自定义状态'),
    divider: true
  },
  {
    value: 'edit',
    content: $t('编辑'),
  },
  {
    value: 'delete',
    content: $t('移除'),
  },
]);

const addDataDialog = reactive<any>({
  show: false,
  data: undefined,
});

const dataBindDialog = reactive<any>({
  show: false,
  data: undefined,
});

const ojbectDialog = reactive<any>({
  show: false,
  data: undefined,
});

const dataSetColumns = [
  {
    colKey: 'row-select',
    type: 'single',
    width: 50,
  },
  // {
  //   colKey: 'device',
  //   title: $t('设备'),
  //   ellipsis: { theme: 'light', trigger: 'context-menu' },
  // },
  {
    colKey: 'label',
    title: $t('显示名称'),
    ellipsis: { theme: 'light', trigger: 'context-menu' },
  },
  {
    colKey: 'id',
    title: $t('变量名'),
    ellipsis: { theme: 'light', trigger: 'context-menu' },
  },
  {
    colKey: 'type',
    title: $t('类型'),
    width: 100,
  },
  {
    colKey: 'mock',
    title: $t('值范围'),
    ellipsis: true,
  },
];

const operatorOptions = ref<any>([
  { label: '=', value: '=' },
  { label: '!=', value: '!=' },
  { label: '>', value: '>' },
  { label: '<', value: '<' },
  { label: '>=', value: '>=' },
  { label: '<=', value: '<=' },
  { label: $t('包含'), value: '[)' },
  { label: $t('不包含'), value: '![)' },
]);

const cProps = [
  {
    value: 'x',
    label: 'X',
  },
  {
    value: 'y',
    label: 'Y',
  },
  {
    value: 'width',
    label: $t('宽'),
  },
  {
    value: 'height',
    label: $t('高'),
  },
  {
    value: 'visible',
    label: $t('显示'),
  },
  {
    value: 'text',
    label: $t('文字'),
  },
  {
    value: 'color',
    label: $t('颜色'),
  },
  {
    value: 'background',
    label: $t('背景颜色'),
  },
  {
    value: 'progress',
    label: $t('进度'),
  },
  {
    value: 'progressColor',
    label: $t('进度颜色'),
  },
  {
    value: 'showChild',
    label: $t('状态'),
  },
  {
    value: 'rotate',
    label: $t('旋转'),
  },
  {
    value: 'disabled',
    label: $t('禁用'),
  },
  {
    value: 'selectedKey',
    label: $t('单选选中值'),
  },
  {
    value: 'animateReverse',
    label: $t('连线动画反向'),
  }
];

const query = reactive<{
  current: number;
  pageSize: number;
  total: number;
  range: any[];
}>({
  current: 1,
  pageSize: 10,
  total: 0,
  range: [],
});

const triggersDialog = reactive<any>({
  show: false,
  data: undefined,
});

const penTree: any = ref([]);

let timer: any;

onBeforeMount(() => {
  // realTimesOptions - 扩展的动态数据下拉列表
  if (props.pen.realTimesOptions) {
    options.value[options.value.length - 1].divider = true;
    options.value.push(...props.pen.realTimesOptions);
  }

  timer = setInterval($forceUpdate, 1000);
});

const addRealTime = (e: any) => {
  if (e.keywords || e.value === 'text') {
    if (!props.pen.realTimes) {
      props.pen.realTimes = [];
    }

    props.pen.realTimes.push({
      label: e.content,
      key: e.value,
      type: e.type,
      keywords: e.keywords,
    });
    return;
  }

  addDataDialog.header = $t('添加动态数据');

  addDataDialog.data = {
    label: e.content,
    key: e.value,
    type: e.type,
    keywords: e.keywords,
  };
  addDataDialog.data.pen = undefined;
  if (e.keywords) {
    addDataDialog.data.label = '';
  }
  addDataDialog.show = true;
};

const onKeyBlur = () => {
  if (addDataDialog.data) {
    let value = getter(props.pen, addDataDialog.data.key);
    if (value) {
      setter(addDataDialog.data, 'value', value);
    } else {
      addDataDialog.data.value = null;
    }
  }
};

const onChangeLabel = () => {
  if (!addDataDialog.data.key) {
    addDataDialog.data.key = addDataDialog.data.label;
  }
};

const onConfirmData = () => {
  const pen = addDataDialog.data.pen || props.pen;
  if (!pen.realTimes) {
    pen.realTimes = [];
  }
  if (!addDataDialog.data.label || !addDataDialog.data.key) {
    MessagePlugin.error($t('数据名或属性名不能为空！'));
    return;
  }
  delete addDataDialog.data.pen;
  if (addDataDialog.header === $t('添加动态数据')) {
    const found = pen.realTimes.findIndex((item: any) => {
      return item.key === addDataDialog.data.key;
    });
    if (found > -1) {
      MessagePlugin.error($t('已经存在相同属性数据！'));
      return;
    }
    if(pen[addDataDialog.data.key] === undefined && addDataDialog.data.key.indexOf('.') !== -1){
      pen[addDataDialog.data.key] = getter(pen, addDataDialog.data.key);
    }
    pen.realTimes.push(addDataDialog.data);
  }

  addDataDialog.show = false;
};

const onMenuMore = (e: any, item: any, i: number) => {
  switch (e.value) {
    case 'edit':
      addDataDialog.header = $t('编辑动态数据');
      setter(item, 'value', getter(props.pen, item.key));
      addDataDialog.data = item;
      addDataDialog.show = true;
      break;
    case 'delete':
      props.pen.realTimes.splice(i, 1);
      meta2d.initBinds();
      break;
    default:
      break;
  }
};

const onBind = (item: any) => {
  dataBindDialog.data = item;
  dataBindDialog.input = '';
  dataBindDialog.selectedIds = [];
  if (item.bind && item.bind.id) {
    dataBindDialog.selectedIds.push(item.bind.id);
  }
  dataBindDialog.show = true;
  getDataset();
};

const onSearchDataset = () => {
  debounce(getDataset, 300);
};

const getDataset = async () => {
  // @ts-ignore
  const data: Meta2dBackData = meta2d.data();
  if (!data.dataset) {
    return;
  }
  dataBindDialog.dataset = data.dataset.devices;
  dataBindDialog.datasetList = data.dataset.devices;
  if(dataBindDialog.device || dataBindDialog.input){
    dataBindDialog.dataset = dataBindDialog.datasetList.filter(
        (item: any) => {
          if (dataBindDialog.device && item.device !== dataBindDialog.device) {
            return;
          }

          return (
            searchPinyin(item.label, dataBindDialog.input) ||
            item.id.indexOf(dataBindDialog.input) > -1
          );
        }
      );
  }
  query.total = dataBindDialog.dataset.length;
  return;

  dataBindDialog.loading = true;
  if (data.dataset.url) {
    const ret: any = await axios.get(data.dataset.url, {
      params: {
        device: dataBindDialog.device || '',
        q: dataBindDialog.input,
        current: query.current,
        pageSize: query.pageSize,
      },
    });
    dataBindDialog.dataset = ret;
    dataBindDialog.url = true;
    query.total = ret.total;
    console.log( dataBindDialog.dataset,
    query.total);
  } else {
    dataBindDialog.url = false;
    if (!dataBindDialog.datasetList) {
      const ret:any = await axios.post(`/api/data/datasource/get`, {
        id: data.dataset.id,
      });
      if (ret?.data?.devices) {
        data.dataset.data = ret.data.devices;
        dataBindDialog.datasetList = data.dataset.data;
        const set = new Set<string>();
        for (const item of dataBindDialog.datasetList) {
          set.add(item.device);
        }
        dataBindDialog.devices = Array.from(set);
      } else {
        dataBindDialog.dataset = [];
        dataBindDialog.devices = [];
        return;
      }
    }

    if (dataBindDialog.device || dataBindDialog.input) {
      dataBindDialog.dataset = dataBindDialog.datasetList.filter(
        (item: any) => {
          if (dataBindDialog.device && item.device !== dataBindDialog.device) {
            return;
          }

          return (
            searchPinyin(item.label, dataBindDialog.input) ||
            item.id.indexOf(dataBindDialog.input) > -1
          );
        }
      );
      query.total = dataBindDialog.datasetList.length;
    } else {
      dataBindDialog.dataset = [...dataBindDialog.datasetList];
      query.total = dataBindDialog.datasetList.length;
    }
    console.log("dataBindDialog",dataBindDialog,dataBindDialog);
  }
  dataBindDialog.loading = false;
};

const onChangePagination = (pageInfo: any) => {
  // router.push({
  //   path: route.path,
  //   query: { current: pageInfo.current, pageSize: pageInfo.pageSize },
  // });
  query.current = pageInfo.current;
  query.pageSize = pageInfo.pageSize;
  getDataset();
};

const onSelectBindsChange = (value: string[], options: any) => {
  if (options.type === 'check') {
    dataBindDialog.selectedIds = value;
    dataBindDialog.data.bind = toRaw(options.selectedRowData[0]);
    if(dataBindDialog.data.bind.id){
      dataBindDialog.data.enableMock = false;
    }
    dataBindDialog.data.mock = dataBindDialog.data.bind.mock;
    dataBindDialog.data.type = dataBindDialog.data.bind.type;
    doBindInit();
  } else if (options.type === 'uncheck') {
    dataBindDialog.selectedIds = [];
    dataBindDialog.data.bind = {};
  }
};

const doBindInit = () => {
  let { id } = dataBindDialog.data;
  if (props.pen.name === 'echarts' && id?.includes('echarts.option.series')) {
    const { replaceMode } = props.pen.echarts;
    const { xAxis } = props.pen.echarts.option;

    let beforeV = getter(props.pen, id);
    if (Array.isArray(beforeV) && replaceMode === 0) {
      //追加
      setter(props.pen, id, []);
      let _key = 'echarts.option.xAxis.data';
      if (Array.isArray(xAxis) && xAxis.length) {
        _key = 'echarts.option.xAxis.0.data';
      }
      setter(props.pen, _key, []);
    }
  }
};

const dataBindonConfirm = () => {
  dataBindDialog.show = false;
  dataBindDialog.datasetList = undefined;
  meta2d.initBinds();
};

const onRemoveBind = () => {
  dataBindDialog.selectedIds = [];
  dataBindDialog.data.bind = undefined;
};

const getBindsDesc = (item: any) => {
  if (item.bind?.label) {
    return item.bind.label;
  }

  if (item.enableMock && item.mock) {
    return item.mock;
  }

  return $t('绑定变量');
};
const { selections } = useSelection();

const changeValue = (prop: string) => {
  updatePen(props.pen, prop);
  selections.pen[prop] = getter(props.pen, prop);
  if (prop === 'iframe') {
    getThumbImg();
  }
  if(prop === 'apiEnable'){
    meta2d.penNetwork(props.pen);
    meta2d.connectNetwork();
  }
};

const onTrigger = (item: any) => {
  if (!item.triggers) {
    item.triggers = [];
  }
  triggersDialog.openedCollapses = [0];
  triggersDialog.data = item;
  triggersDialog.show = true;

  penTree.value = getPenTree();
};

const onAddTrigger = () => {
  const i = triggersDialog.data.triggers.length;
  triggersDialog.data.triggers.push({
    name: $t(`状态`)+ (i + 1),
    conditionType: 'and',
    conditions: [],
    actions: [],
  });

  triggersDialog.openedCollapses.push(i);
};

const addTriggerCondition = (trigger: any) => {
  trigger.conditions.push({
    type: '',
    operator: '=',
    valueType: '',
  });
};

const onChangeTriggerTarget = (c: any) => {
  /*
  c.targetProps = [
    {
      value: 'x',
      label: 'X',
    },
    {
      value: 'y',
      label: 'Y',
    },
    {
      value: 'width',
      label: $t('宽'),
    },
    {
      value: 'height',
      label: $t('高'),
    },
    {
      value: 'visible',
      label: $t('显示'),
    },
    {
      value: 'text',
      label: $t('文字'),
    },
    {
      value: 'progress',
      label: $t('进度'),
    },
    {
      value: 'showChild',
      label: $t('状态'),
    },
    {
      value: 'rotate',
      label: $t('旋转'),
    },
  ];*/

  const target: any = meta2d.findOne(c.target);
  if (target && target.realTimes) {
    for (const item of target.realTimes) {
      const found = cProps.findIndex((elem: any) => elem.value === item.key);
      if (found < 0) {
        cProps.push({
          value: item.key,
          label: item.label,
        });
      }
    }
  }
};

const onInput = (item: any) => {
  item.label = item.value;
};

const editObject = (item: any) => {
  ojbectDialog.data = props.pen[item.key];
  ojbectDialog.item = item;
  ojbectDialog.pen = undefined;
  ojbectDialog.show = true;
};

const onOkEditOjbect = () => {
  if (ojbectDialog.data) {
    if (
      ojbectDialog.item.type === 'array' &&
      !Array.isArray(ojbectDialog.data)
    ) {
      MessagePlugin.error($t('请输入数组格式数据'));
      return;
    }
    const pen = ojbectDialog.pen || props.pen;
    pen[ojbectDialog.item.key] = deepClone(ojbectDialog.data);
    updatePen(
      pen,
      ojbectDialog.item.key
    );
    ojbectDialog.show = false;
  } else {
    MessagePlugin.error($t('请输入严格的JSON格式数据'));
  }
};

const propsDialog = reactive<any>({
  show: false,
});

// const changeValue = (prop: string) => {
//   updatePen(props.pen, prop);
//   selections.pen[prop] = getter(props.pen, prop);
//   if (prop === 'iframe$t(') {
//     getThumbImg();
//   }
// };

const getThumbImg = async () => {
  //改iframe地址后
  let arr = props.pen.iframe.split('?');
  let id = queryURLParams(arr[1]).id;
  if (!id) {
    return;
  }
  // let projection = {
  //   image: 1,
  //   _id: 1,
  //   name: 1,
  // };
  let projection = 'image,id,name';
  let res: any;
  if (arr[0].indexOf('2d.le5le') !== -1||arr[0].indexOf('le5le.com/2d') !== -1) {
    res = await getLe5le2d(id, projection);
  } else if (arr[0].indexOf('v.le5le') !== -1||arr[0].indexOf('le5le.com/v') !== -1) {
    res = await getLe5leV(id, projection);
  } else if (arr[0].indexOf('3d.le5le') !== -1||arr[0].indexOf('le5le.com/3d') !== -1) {
    res = await getLe5le3d(id, projection);
  }
  if (res) {
    props.pen.thumbImg = res.image;
    props.pen.calculative&&(props.pen.calculative.img = null);
  }
  props.pen.onRenderPenRaw?.(props.pen);
};

const preShowPropsEdit = (key: string) => {
  showPropsEdit({
    key,
    // item: {
    // key,
    type: 'code',
    label: key,
    placeholder: '支持设置动态参数，例如：{"Authorization": "Bearer ${token}"}',
    // },
  });
};

const showPropsEdit = (item: any) => {
  propsDialog.key = item.key;
  propsDialog.header = `${item.label}(${item.key})`;
  propsDialog.value = props.pen[item.key];
  propsDialog.placeholder = item.placeholder;
  propsDialog.show = true;
};

const onOkPropsEdit = () => {
  if (!propsDialog.value) {
    MessagePlugin.error($t('数据不满足json格式'));
    return;
  }
  props.pen[propsDialog.key] = propsDialog.value;
  updatePen(props.pen, propsDialog.key);
  propsDialog.show = false;
};

const codeChange = (e:any,a:any)=>{
  a.fn = null;
}

const valueChange = (e,c:any)=>{
  c.value= changeType(e);
}

const drawer = reactive<any>({
  visible: false,
});

const showDrawer = (item:any)=>{
  drawer.key = item.key;
  drawer.header = `${item.label}(${item.key})`;
  drawer.value = deepClone(props.pen[item.key]);
  drawer.placeholder = item.placeholder;
  drawer.randomkey = s8();//props.pen.id;
  drawer.visible = true;
}

const onConfirmDrawer = () => {
  if (!drawer.value) {
    MessagePlugin.error($t('数据不满足json格式'));
    return;
  }
  props.pen[drawer.key] = drawer.value;
  updatePen(props.pen, drawer.key);
};

const childrenPens = ref([]);

watch(
  () => props.pen.id,
  (newValue) => {
    childrenPens.value = [];
      // childrenKey.value = s8();
    if(props.pen.children?.length){
      childrenPens.value = getAllChildren(meta2d.store.pens[props.pen.id],meta2d.store);
    }
  }
);

onMounted(() => {
  childrenPens.value = [];
  if(props.pen.children?.length){
    childrenPens.value = getAllChildren(meta2d.store.pens[props.pen.id],meta2d.store);
  }
});

const changeCValue = (prop: string, pen:Pen)=>{
  updatePen(pen, prop);
  selections.pen[prop] = getter(pen, prop);
  if (prop === 'iframe') {
    getThumbImg();
  }
  if(prop === 'apiEnable'){
    meta2d.penNetwork(pen);
    meta2d.connectNetwork();
  }
}

const editCObject = (item: any, pen:Pen) => {
  ojbectDialog.data = pen[item.key];
  ojbectDialog.pen = pen;
  ojbectDialog.item = item;
  ojbectDialog.show = true;
};

const addCRealTime = (e: any, pen:Pen) => {
  if (e.keywords || e.value === 'text') {
    if (!pen.realTimes) {
      pen.realTimes = [];
    }

    pen.realTimes.push({
      label: e.content,
      key: e.value,
      type: e.type,
      keywords: e.keywords,
    });
    return;
  }

  addDataDialog.header = $t('添加动态数据');
  
  addDataDialog.data = {
    label: e.content,
    key: e.value,
    type: e.type,
    keywords: e.keywords,
  };
  addDataDialog.data.pen = pen;
  if (e.keywords) {
    addDataDialog.data.label = '';
  }
  addDataDialog.show = true;
};

const onCMenuMore = (e: any, item: any, i: number, pen:any)=>{
  switch (e.value) {
    case 'edit':
      addDataDialog.header = $t('编辑动态数据');
      setter(item, 'value', getter(pen, item.key));
      addDataDialog.data = item;
      addDataDialog.data.pen = pen;
      addDataDialog.show = true;
      break;
    case 'delete':
      pen.realTimes.splice(i, 1);
      meta2d.initBinds();
      break;
    case 'custom':
      if(!pen.triggers){
        pen.triggers = [];
      }
      pen.triggers.push({
        name: $t(`状态场景`) + (pen.triggers.length + 1),
        status:[
          {
            name:$t('状态1'),
            conditionType: 'and',
            conditions: [{
              type:'',
              operator: "=",
              key: item.key,//"text",
              keyLabel: item.label,
              value: undefined
            }],
            actions: [],
          },
          {
            name:$t('状态2'),
            conditionType: 'and',
            conditions: [],
            actions: [],
          }
        ],
      });
      meta2d.active(meta2d.find(pen.id));
      emit('tabchange',pen.triggers.length-1);
      break;
    case 'view':
      meta2d.active(meta2d.find(pen.id));
      emit('tabchange',-1);
    default:
      break;
  }
}

const emit = defineEmits(['tabchange']); 

const triggerOptions = computed(() => {
  const options =   [
    {
      value: 'custom',
      content: $t('自定义状态'),
      divider: true
    },

    {
      value: 'warning',
      content: $t('条件告警'),
    },
    {
      value: 'warningAnimate',
      content: $t('条件动画'),
      divider: true
    },
    {
      value: 'edit',
      content: $t('编辑'),
    },
    {
      value: 'delete',
      content: $t('移除'),
    },
  ]
  if( props.pen.name === "combine"&& props.pen.showChild !== undefined){
    options.splice(1,0,
    {
      value: 'switch',
      content: $t('状态切换'),
    });
  }
  
  return options
});

const addTrigger = (item:any, e:any, i:any) => {
  if(!['edit', 'delete'].includes(e.value)){
    if(!props.pen.triggers){
      props.pen.triggers = [];
    }
  }

  switch (e.value) {
    case 'edit':
      addDataDialog.header = $t('编辑动态数据');
      setter(item, 'value', getter(props.pen, item.key));
      addDataDialog.data = item;
      addDataDialog.show = true;
      break;
    case 'delete':
      props.pen.realTimes.splice(i, 1);
      meta2d.initBinds();
      break;
    case 'switch':
      props.pen.triggers.push({
        "name": e.content,
        "status": [
            {
              "name": $t("满足条件，切换到状态1"),
              "conditionType": "and",
              "conditions": [
                  {
                      "type": "",
                      "operator": ">=",
                      "key": item.key,
                      "keyLabel": item.label,
                      "valueType": ""
                  }
              ],
              "actions": [
                  {
                      "action": 1,
                      "params": "",
                      "value": {
                          "showChild": 1
                      },
                      "targetType": "id"
                  }
              ]
            },
            {
                "name": $t("默认显示状态"),
                "conditionType": "and",
                "conditions": [],
                "actions": [
                    {
                        "action": 1,
                        "params": "",
                        "value": {
                            "showChild": 0
                        },
                        "targetType": "id"
                    }
                ]
            }
        ]
      });
      break;
    case 'warning':
      props.pen.triggers.push({
        "name": e.content,
        "status": [
            {
                "name": $t("满足条件，触发告警"),
                "conditions": [
                    {
                        "type": "",
                        "operator": ">=",
                        "valueType": "",
                        "key": item.key,
                        "keyLabel":item.label,
                        "value": undefined
                    }
                ],
                "actions": [
                    {
                        "action": 1,
                        "params": "",
                        "value": {
                            "background": "red",
                        },
                        "targetType": "id"
                    }
                ],
                "conditionType": "and"
            },
            {
                "name": $t("恢复默认"),
                "conditionType": "and",
                "conditions": [],
                "actions": [
                    {
                        "action": 1,
                        "params": "",
                        "value": {
                            "background": "#0000",
                        },
                        "targetType": "id"
                    }
                ]
            }
        ]
      });
      break;
    case 'warningAnimate':
      props.pen.triggers.push({
        "name": e.content,
        "status": [
            {
                "name": $t("满足条件，触发动画执行"),
                "conditions": [
                    {
                        "type": "",
                        "operator": ">=",
                        "valueType": "",
                        "key": item.key,
                        "keyLabel":item.label,
                        "value": undefined
                    }
                ],
                "actions": [
                    {
                        "action": 2,
                        "params": "",
                        "value": "",
                        "targetType": "id",
                    }
                ],
                "conditionType": "and"
            },
            {
                "name": $t("恢复默认状态"),
                "conditionType": "and",
                "conditions": [],
                "actions": [
                    {
                        "action": 4,
                        "params": "",
                        "value": "",
                        "targetType": "id"
                    }
                ]
            }
        ]
      });
      break;
    case 'custom':
      props.pen.triggers.push({
        name: $t(`状态场景`) + (props.pen.triggers.length + 1),
        status:[
          {
            name:$t('状态1'),
            conditionType: 'and',
            conditions: [{
              type:'',
              operator: "=",
              key: item.key,//"text",
              keyLabel: item.label,
              value: undefined
            }],
            actions: [],
          },
          {
            name:$t('状态2'),
            conditionType: 'and',
            conditions: [],
            actions: [],
          }
        ],
      });
      break;
  }
  if(!['edit', 'delete'].includes(e.value)){
    emit('tabchange',props.pen.triggers.length-1);
  }
}

const cell = ref({
  col:undefined,
  row:undefined
});

const getPenData = (e)=>{
  if(props.pen.name === 'tablePlus'){
   if(props.pen.calculative.activeRow !== undefined){
      cell.value.row = props.pen.calculative.activeRow;
      cell.value.col = undefined;
    }else if(props.pen.calculative.activeCell){
      cell.value.col = props.pen.calculative.activeCell.col;
      cell.value.row = props.pen.calculative.activeCell.row;
    }else{
      cell.value.col = undefined;
      cell.value.row = undefined;
    }
  }
}

const onQuickBind = ()=>{
  if(cell.value.row !== undefined){
    if(!props.pen.realTimes){
      props.pen.realTimes = [];
    }
    let row = cell.value.row;
    if(props.pen.colHeaders){
      row-=1;
    }
    if(cell.value.col !== undefined){
      let found = props.pen.realTimes.findIndex((item:any)=>{
        return item.key === `data.${cell.value.row}.${cell.value.col}`;
      });
      if(found === -1){
        props.pen.realTimes.push({
          label: `第${row+1}行，第${cell.value.col}列`,
          key: `data.${row}.${cell.value.col}`,
          type: 'float',
        });
        onBind(props.pen.realTimes[props.pen.realTimes.length-1]);
      }else{
        onBind(props.pen.realTimes[found]);
      }
    }else{
      let found = props.pen.realTimes.findIndex((item:any)=>{
        return item.key === `data.${cell.value.row}`;
      });
      if(found === -1){
        props.pen.realTimes.push({
          label: `第${row+1}行`,
          key: `data.${row}`,
          type: 'array',
        });
        onBind(props.pen.realTimes[props.pen.realTimes.length-1]);
      }else{
        onBind(props.pen.realTimes[found]);
      }
    }
  }
}

const dataSource = ref('');

const getDataSource = async (e) => {
  dataSource.value = '';
  if (e === 'excel') {
    let data = await importExcel();
    if (Array.isArray(data) && Array.isArray(data[0])) {
      meta2d.setValue({ id: props.pen.id, data: data, styles: [], mergeCells: [], colHeaders: false }, { doEvent: false });
    } else {
      MessagePlugin.warning($t("数据格式必需是二维数组"));
    }
  } else if (e === 'csv') {
    let data = await importCSV();
    if (Array.isArray(data) && Array.isArray(data[0])) {
      meta2d.setValue({ id: props.pen.id, data: data, styles: [], mergeCells: [], colHeaders: false }, { doEvent: false });
    } else {
      MessagePlugin.warning($t("数据格式必需是二维数组"));
    }
  } else if (e === 'api') {
    apiDialog.show = true;
  }
}

const apiDialog = reactive<any>({
  show: false,
});

const onConfirmAPI = async () => {
  if (!apiDialog.url) {
    MessagePlugin.warning($t('请输入API地址'));
    return;
  }
  const res: Response = await fetch(apiDialog.url, {
    headers: apiDialog.headers,
    method: apiDialog.method || 'GET',
    body: apiDialog.method === 'GET' ? undefined : JSON.stringify(apiDialog.body),
  });
  let data: any = JSON.parse(await res.text());
  if (data.data) {
    data = data.data;
  }
  if (data.list) {
    data = data.list;
  }

  if (Array.isArray(data)) {
    if (Array.isArray(data[0])) {
    } else {
      let _data = [];
      data.forEach((item) => {
        _data.push(Object.values(item));

      })
      data = _data;
    }
    if (Array.isArray(data) && Array.isArray(data[0])) {
      meta2d.setValue({ id: props.pen.id, data: data, styles: [], mergeCells: [], colHeaders: false }, { doEvent: false });
      MessagePlugin.success($t("导入成功"));
    } else {
      MessagePlugin.warning($t("数据格式必需是二维数组"));
    }
    apiDialog.show = false;
  } else {
    MessagePlugin.warning($t("数据格式必需是数组类型"));
  }
};

const leaderPen = ref(null);
const watcher = watch(
  () => props.pen.id,
  async () => {
    leaderPen.value = meta2d.store.pens[props.pen.formId];
  }
);

onMounted(() => {
   meta2d.on('click',getPenData);
   leaderPen.value = meta2d.store.pens[props.pen.formId];
   getPenData({});
});

onUnmounted(() => {
  meta2d.off('click',getPenData);
  watcher();
  clearInterval(timer);
});
</script>
<style lang="postcss" scoped>
.props {
  height: 100%;

  .grid {
    grid-template-columns: 70px 70px 50px 65px;
    padding: 0 12px;

    &.head {
      background: var(--color-background-input);
      line-height: 36px;
      margin-bottom: 6px;

      .title {
        line-height: 36px;
      }
    }
  }

  .blank {
    height: 70%;
    img {
      padding: 16px;
      opacity: 0.9;
    }
  }
  .c-titile{
    margin-top: 12px;
    color: var(--color-title);
    font-size: 12px;
    font-weight: 700;
  }
  .c-head{
    &::before{
      width: 0%;
    }
    color: var(--color);
    font-weight: 700;
  }
  .real-times{
    .label {
      width: fix-content;
      font-size: 10px;
      line-height: 28px;
      color: var(--color-desc);
    }
  }

  .value {
    padding-right: 8px;
    display: flex;
    align-items: center;
    justify-content: space-between;

    svg {
      flex-shrink: 0;
      margin-right: 4px;
    }

    & > div {
      width: 72px;
      &.t-switch {
        width: fit-content;
        margin-left: 4px;
      }
    }

    :deep(.t-input) {
      padding-left: 4px;
      height: 26px;
      border-color: transparent;
      &:hover {
        border-color: var(--color-primary);
      }
    }
  }

  .actions {
    text-align: right;
    padding-right: 2px;
  }

  .data-list {
    :deep(.t-table__header--fixed:not(.t-table__header--multiple) > tr > th) {
      background: none;
    }

    :deep(.t-table__pagination) {
      padding-bottom: 0;
    }
  }
  .form-item{
    height: 32px;
  }
}

.body {
  :deep(.t-collapse.t--border-less) {
    .t-collapse-panel__header {
      border-top: none;
      /* border-bottom: 1px solid var(--td-border-level-1-color); */
      padding: 8px 0;

      .t-input {
        border: none;
        padding-left: 0;
        font-size: 14px;
      }
    }

    .t-collapse-panel__content {
      padding: 8px 0;
    }
  }

  .title {
    position: relative;
    margin: 8px 0;

    :deep(.t-input) {
      border-color: var(--color-background-input);
      border-radius: 0;
      border-left: none;
      border-top: none;
      border-right: none;
      padding-left: 0;
      padding-bottom: 8px;
      font-size: 14px;

      &:hover {
        border-color: var(--color-border-input);
      }
    }
  }

  .head {
    margin-top: 10px;
  }

  .banner {
    background-color: var(--color-background-input);
    padding: 0 12px;
  }
}
</style>

<style lang="postcss">
.t-drawer__mask{
  /* background-color: #fff0; */
}

.t-drawer__body{
  padding:0px;
}
</style>